<template>
  <q-item v-if="!additionalField"  clickable v-ripple>
    <q-field dense standout :prefix="prefix" :suffix="suffix" class="w-full" >
      <template v-slot:prepend>
        <q-icon class="mt-2" :name="iconName"/>
      </template>

      <template v-slot:control >
        <q-input
          v-if="prefix !== 'Город:'"
          v-model="model"
          input-class="text-right"
          :class="{'w-full':inputFull, 'w-40':!inputFull}"
          class="ml-auto"
          @update:model-value="useDebounce"
          :disable="!isAuth || disable"
        >
          <template v-if="whatsapp" v-slot:before>
            <a @click.stop :href="`https://wa.me/${formatPhoneNumber(model)}`" target="_blank"><img src="../assets/img/icons/whatsapp.svg" width="25" class="ml-6"></a>
            <a @click.stop :href="`https://t.me/${formatPhoneNumber(model)}`" target="_blank"><img src="../assets/img/icons/telegram.png" width="21" class="ml-1 opacity-60 hover:opacity-100"></a>
<!--            <a @click.stop :href="`viber://chat?number=${formatPhoneNumber(model)}`" target="_blank"><img src="../assets/img/icons/viber.png" width="26" class="ml-1 opacity-60 hover:opacity-100"></a>-->
          </template>
          <template v-if="whatsapp" v-slot:after>
            <q-btn flat round :icon="!isCopy && 'content_copy' || 'done'" size="xs" dense @click="copyText(model)">
              <q-tooltip v-if="!isCopy">Копировать</q-tooltip>
            </q-btn>
          </template>
        </q-input>
        <q-select
          v-if="prefix === 'Город:'"
          :model-value="model"
          v-model="model"
          :options="cities"
          :loading="loadingCities"
          :class="{'w-full':inputFull, 'w-40':!inputFull}"
          class="text-right"
          @filter="fnFilter"
          map-options
          dense

          :disable="!isAuth"
          @update:model-value="useDebounce"
        >
          <template v-slot:selected-item="item">
            <q-item-section>
              <q-item-label class="ml-auto text-right" v-html="item.opt" />
            </q-item-section>
          </template>
        </q-select>
      </template>
      <template v-slot:after>
        <q-btn v-if="iconUrl" @click.stop :href="iconUrl" target="_blank" class="mt-2" round dense flat icon="email" />
      </template>
    </q-field>
  </q-item>
  <q-field v-else-if="type==='Текст' || type==='Цифровое'" :disable="!isAuth" dense standout :prefix="prefix" :suffix="suffix" class="w-full">
    <template v-slot:control>
      <q-input
        v-model="model.value"
        :model-value="model.value"
        input-class="text-right"
        :class="{'w-full':inputFull, 'w-40':!inputFull}"
        class="ml-auto"
        @update:model-value="useDebounce"
        :loading="loading"
        :disable="!isAuth"
        :mask="mask"
      >
        <template v-if="whatsapp" v-slot:before>
          <a @click.stop :href="`https://wa.me/${model.value}`" target="_blank"><img src="../assets/img/icons/whatsapp.svg" width="25" class="ml-6"></a>
        </template>
      </q-input>
    </template>
  </q-field>
  <q-field v-else-if="type==='Чекбокс'" :disable="!isAuth" dense standout :prefix="prefix" :suffix="suffix" class="w-full">
    <template v-slot:control>
      <q-toggle
        v-model="model.value"
        :model-value="model.value"
        class="ml-auto"
        @update:model-value="useDebounce"
      />
    </template>
  </q-field>
  <q-field v-else-if="type==='Список'" :disable="!isAuth" dense standout :prefix="prefix" :suffix="suffix" class="w-full">
    <template v-slot:control>
      <q-select
        v-model="model.value"
        :model-value="model.value"
        :options="option"
        class="ml-auto"
        @update:model-value="useDebounce"
      />
    </template>
  </q-field>
</template>

<script>
import {ref, watch} from "vue"
import api from "../API/api";
import {useDebounce} from "./useDebounce";
import {useRoute} from "vue-router";
import {useUpdateLead} from "./useUpdateLead";
import {formatPhoneNumber} from "./utils/formatPhoneNumber";
import {useStore} from "vuex";

let stringOptions = [].reduce((acc, opt) => {
  for (let i = 1; i <= 5; i++) {
    acc.push(opt + ' ' + i)
  }
  return acc
}, [])
export default {
  name: "Lead_Fin_Field",
  props: {
    additionalField: { type: Boolean, required: false, default: false },
    type: { type: String, required: false, default: 'Текст' },
    prefix: { type: String, required: false, default: '' },
    suffix: { type: String, required: false, default: '' },
    iconName: { type: String, required: false, default: '' },
    iconUrl: { type: String, required: false, default: '' },
    model: { required: true, default: '' },
    keyObj: { required: true, default: '' },
    option: { type: Array, required: false, default: [] },
    inputFull: { type: Boolean, required: false, default: false },
    whatsapp: { type: Boolean, required: false, default: false },
    telegram: { type: Boolean, required: false, default: false },
    index: { type: Number, required: false, default: null },
    fields: { type: Array, required: false, default: [] },
    disable: { type: Boolean, required: false, default: false },
    mask: { type: String, required: false, default: '' },
  },
  setup (props, {emit}) {
    const route = useRoute();
    const _id = route.params.id
    const cities = ref([])
    const loading = ref(false)
    const loadingCities = ref(false)
    const store = useStore()
    const isAuth = store.getters.isAuth
    const isCopy = ref(false)

    async function fnFilter (val, update, abort) {
      loadingCities.value = true
      await api.getCities().then(res => {
        stringOptions = res.data.cities.map(el => el.city)
        loadingCities.value = false
        update(() => {
          const needle = val.toLocaleLowerCase()
          cities.value = stringOptions.filter(v => v.toLocaleLowerCase().indexOf(needle) > -1)
        })
      })
      update(() => {
        const needle = val.toLocaleLowerCase()
        cities.value = stringOptions.filter(v => v.toLocaleLowerCase().indexOf(needle) > -1)
      })
    }

    // watch(() => props.model, (newValue, oldValue) => {
    //   // Выполняется при изменении значения пропса initialMessage
    //   if (oldValue !== undefined) {
    //     console.log(props.keyObj, newValue)
    //   }
    //   // useDebounce(useUpdateLead(_id, props.keyObj, props.model), 500)
    // }, { immediate: false });
    function copyText(val) {
      // Создаем временный элемент textarea
      let tempInput = document.createElement("textarea");

      // Устанавливаем значение временного элемента
      tempInput.value = val;

      // Добавляем временный элемент в документ
      document.body.appendChild(tempInput);

      // Выделяем текст во временном элементе
      tempInput.select();

      try {
        // Копируем текст в буфер обмена
        document.execCommand('copy');
        isCopy.value = true
      } catch (err) {
        console.error('Не удалось скопировать текст: ', err);
      }

      // Удаляем временный элемент из документа
      document.body.removeChild(tempInput);
    }

    return {
      cities,
      isAuth,
      loadingCities,
      loading,
      isCopy,
      copyText,
      fnFilter,
      formatPhoneNumber,
      useDebounce: useDebounce(async function () {
        loading.value = true
        if (props.fields.length) {
          const fields = props.fields
          fields[props.index] = props.model
          const payload = {_id, key: props.keyObj, value: fields, index: props.index}
          await useUpdateLead(payload)
            .then(() => {
              // обновить значения в Lead
              emit('updateField', payload)
            })
        } else {
          const payload = {_id, key: props.keyObj, value: props.model, index: props.index}
          useUpdateLead(payload)
              .then(() => {
                // обновить значения в Lead
                emit('updateField', payload)
              })
        }
        loading.value = false
      }, 800),
      // updateLead:
    }
  }
}
</script>

<style scoped>

</style>
